<?php

namespace Teknisa\SUP\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\Report\Strategy\BirtStrategy;
use Teknisa\SUP\Modules\Parametros\Services\Sup09800MarcasPorFornecedorParaPedidoDeColetaService;

class Sup09800MarcasPorFornecedorParaPedidoDeColetaController extends \Zeedhi\Framework\Controller\Report
{
    protected $QR2Strategy;
    protected $stNomeRel;
    
    
	public function __construct($reportService, $QR2Strategy, Sup09800MarcasPorFornecedorParaPedidoDeColetaService $service)
	{
	    parent::__construct($reportService);
	    $this->QR2Strategy  = $QR2Strategy;
	    $this->service = $service;
	}

    public function addMarcaFornecedor(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        if(!empty($row)){
            $this->service->addMarcaFornecedor($row);
        }
    }
    
    public function addCadastramentoAutomatico(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        if(!empty($row)){
            $this->service->addCadastramentoAutomatico($row);   
        }
    }
    
    public function deleteMarcaFornecedor(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        if(!empty($row)){
            $this->service->deleteMarcaFornecedor($row);
        }
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $this->QR2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array (
            'strategy' => $row['STRATEGY'],
            'parameterMapping' =>
                array (
                     "CDFORNECED" => "P_CDFORNECED",
                     "CDMARCA"    => "P_CDMARCA"
                ),
            );
    }
}
